%global _exec_prefix /
%global apple_version 540.1

Summary:        Tools to create/check Apple HFS+ filesystems
Name:           hfsplus-tools
Version:        540.1.linux3
Release:        6%{?dist}
License:        APSL 2.0
URL:            http://gentoo-wiki.com/HOWTO_hfsplus

## files include:
## https://github.com/mackyle/blocksruntime/tree/master/BlocksRuntime
## https://opensource.apple.com/source/diskdev_cmds/diskdev_cmds-%{apple_version}/{fsck_hfs.tproj,newfs_hfs.tproj}
## https://opensource.apple.com/source/Libc/Libc-825.26/include/bitstring.h
## https://opensource.apple.com/source/xnu/xnu-517.9.5/bsd/hfs/
## https://opensource.apple.com/source/xnu/xnu-517.9.5/bsd/sys/
## https://opensource.apple.com/source/ruby/ruby-79/ruby/missing.h
Source0:        https://opensource.apple.com/source/diskdev_cmds/diskdev_cmds-%{apple_version}#/diskdev_cmds-%{version}.tar.gz
Source1:        http://www.opensource.org/licenses/apsl-2.0.txt
Patch3000:      hfsplus-tools-no-blocks.patch
Patch3001:      hfsplus-tools-learn-to-stdarg.patch
Patch3002:      hfsplus-tools-sysctl.patch


BuildRequires:  gcc, make
BuildRequires:  openssl-devel, libuuid-devel



%description
HFS+, HFS Plus, or Mac OS Extended are names for a file system developed by
Apple Computer to replace their Hierarchical File System (HFS). In addition to
being the default file system on modern Apple computers, HFS+ is one of two
formats, FAT being the other, that are supported by the iPod hard-disk based
music player. Unlike FAT, HFS+ supports UNIX style file permissions, which
makes it useful, for serving and sharing files in a secured manner. As Apple
Computer's devices and systems become increasingly ubiquitous, it becomes
important that Linux fully support this format.

This package provides tools to create and check HFS+ filesystems under Linux.



%prep
%autosetup -p1 -n diskdev_cmds-%{version}



%build
%make_build


%install
mkdir -p %{buildroot}/%{_sbindir}
mkdir -p %{buildroot}/%{_mandir}/man8

cp newfs_hfs.tproj/newfs_hfs %{buildroot}/%{_sbindir}/mkfs.hfsplus
cp fsck_hfs.tproj/fsck_hfs %{buildroot}/%{_sbindir}/fsck.hfsplus
cp %{SOURCE1} .

cat fsck_hfs.tproj/fsck_hfs.8 | sed -e 's/[F|f]sck_hfs/fsck.hfsplus/g' \
    > %{buildroot}/%{_mandir}/man8/fsck.hfsplus.8
cat newfs_hfs.tproj/newfs_hfs.8 | sed -e 's/[N|n]ewfs_hfs/mkfs.hfsplus/g' \
    > %{buildroot}/%{_mandir}/man8/mkfs.hfsplus.8

pushd %{buildroot}/%{_sbindir}
ln -s fsck.hfsplus fsck.hfs
popd


pushd %{buildroot}/%{_mandir}/man8
ln -s fsck.hfsplus.8 fsck.hfs.8
popd



%files
%license apsl-2.0.txt
%{_sbindir}/mkfs.hfsplus
%{_sbindir}/fsck.hfsplus
%{_sbindir}/fsck.hfs
%{_mandir}/man8/mkfs.hfsplus.8.gz
%{_mandir}/man8/fsck.hfsplus.8.gz
%{_mandir}/man8/fsck.hfs.8.gz



%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 540.1.linux3-6
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 540.1.linux3-5
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 540.1.linux3-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 540.1.linux3-3
- Rebuilt for OpenCloudOS Stream 23

* Mon Feb 06 2023 cunshunxia <cunshunxia@tencent.com> - 540.1.linux3-2
- update the source0 url.

* Wed Sep 7 2022 cunshunxia <cunshunxia@tencent.com> - 540.1.linux3-1
- initial build
